#!/bin/bash

MOUNT_POINT=$1

while [ 1 ];
do
	if [ -f /tmp/acsrestore.file ]; then
		BACKUP_FILE=`cat /tmp/acsrestore.file`

		if [ ! -e /opt/agileacs_backup/$BACKUP_FILE ]; then
			exit
		fi

		SOURCE_FILE_SIZE=0
		DEST_FILE_SIZE=0

		if [ -e /opt/agileacs_backup/$BACKUP_FILE ]; then
			DEST_FILE_SIZE=`ls -al /opt/agileacs_backup/$BACKUP_FILE | awk '{ print $5}'`
		fi
		if [ -e $MOUNT_POINT/$BACKUP_FILE ]; then
			SOURCE_FILE_SIZE=`ls -al $MOUNT_POINT/$BACKUP_FILE | awk '{ print $5}'`
		fi
		#if [ -e /tmp/agileacs_usb.mount_point/$BACKUP_FILE ]; then
		#	DEST_FILE_SIZE=`ls -al /tmp/agileacs_usb.mount_point/$BACKUP_FILE | awk '{ print $5}'`
		#fi

		if [ "$SOURCE_FILE_SIZE" != "0" ] && [ "$DEST_FILE_SIZE" != "0" ]; then
			echo $(($DEST_FILE_SIZE * 100 / $SOURCE_FILE_SIZE)) > /tmp/acsrestore.progress
		fi
	else
		echo "0" > /tmp/acsrestore.progress
	fi
	sleep 5
done

