#!/bin/sh

FILE_ACTIVATE_REPORT_STATUS="/opt/agileacs/tmp/yk5k4325fkrv156k7rvq"

# return 0(not ready), 1(ready)
get_status() {

    if [ ! -f ${FILE_ACTIVATE_REPORT_STATUS} ]; then
        /opt/agileacs/bin/acsutils2 activatereport switch check >> /dev/null 2>&1
    fi

    if [ ! -f ${FILE_ACTIVATE_REPORT_STATUS} ]; then
         echo "0"
         return
    fi

    status=`cat $FILE_ACTIVATE_REPORT_STATUS`
    if [ "${status}" != "0" ] && \
    [ "${status}" != "1" ]; then
        echo "0"
    else
        echo "${status}"
    fi
    return
}

get_status
exit 0
