#!/bin/bash

FEATURE_SET_FILE="/opt/agileacs/tmp/xj4j32l4ejvu045j6vup"

# check if the feature is pro feature
# $1: feature to check
# return: true/false (value stored in db)
is_pro_feature() {
  # when result is null or result['$1'] is not set, default to true
  query="var result=db.pro_features.findOne({_id:'pro_features'});print((!result)||result['$1']===undefined||result['$1']?true:false)"
  until is_pro_feature=`mongo ${dbTplink:-localhost:27017/tplink} ${queryOptions:---quiet --eval} "${query}"` ; do
    # waiting for retry to check if xmpp pro feature
    sleep 1
  done

  echo $is_pro_feature
}

# return pro/lite
get_current_feature_set() {
  [ "$(cat ${FEATURE_SET_FILE})" = "lite" ] && echo "lite" || echo "pro"
}
