#!/bin/sh
if tmux has-session -t 'profanity'; then
  echo "Profanity is already running."
  echo "To stop it use: ./profanity-stop.sh"
  echo "To attach to it use: tmux attach -t profanity"
else
  tmux new-session -s 'profanity' -d
  tmux send-keys '/opt/agileacs/bin/profanity' 'C-m'
  tmux select-layout tiled 2>/dev/null
  tmux rename-window 'XmppClient'
fi
