# SessionsController
class SessionsController < ApplicationController
  include Loggers
  include Util
  def new
    redirect_to '/' if logged_in?
    Rails.configuration.users = {} # clean cache
  end

  def create
    fetch_permissions_from_db if $de_change == true
    if begin
          Rails.configuration.users[params[:username]]['password'].to_s == params[:password]
       rescue StandardError
         false
        end
      log_message(6, "#{params[:username]} login succeed from #{request.headers['HTTP_X_FORWARDED_FOR']}.")
      session[:username] = params[:username]
      redirect_to root_url
    else
      log_message(3, "#{params[:username]} login failed from #{request.headers['HTTP_X_FORWARDED_FOR']}.")
      flash.now.alert = 'Invalid username or password'
      render 'new'
    end
  end

  def destroy
    session[:username] = nil
    redirect_to log_in_path
  end

  def log_message(levelnum, acs_log)
    task = { 'levelnum' => levelnum, 'user' => params[:username] }
    agileACSLog(levelnum, '[Login]', acs_log)
    create_api_conn().post('/sessions/login_counts', ActiveSupport::JSON.encode(task), 'Content-Type' => 'application/json')
  end
end
