# Devices > show > info + Refresh and filters(shared)
GenieacsGui::Application.config.summary_parameters_tplink = YAML.load_file('config/tplink/summary_parameters.yml')

# Devices > table and filters(shared)
GenieacsGui::Application.config.index_parameters_tplink = YAML.load_file('config/tplink/index_parameters.yml')

# Country for Activate License Information
GenieacsGui::Application.config.country = YAML.load_file('config/tplink/country.yml')

GenieacsGui::Application.config.index_parameters = YAML.load_file('config/index_parameters.yml')

GenieacsGui::Application.config.device_filters = { 'Last inform' => ['_lastInform'], 'Tag' => ['_tags'] }

GenieacsGui::Application.config.index_parameters.each do |k, v|
  v = Array(v)
  GenieacsGui::Application.config.index_parameters[k] = v

  v.each do |vv|
    GenieacsGui::Application.config.device_filters[k] ||= []
    GenieacsGui::Application.config.device_filters[k].push(vv)
  end
end

GenieacsGui::Application.config.device_filters.each { |_, v| v.uniq! }

GenieacsGui::Application.config.menu = []
tabs = Dir.glob("#{Rails.root}/config/tplink/menu/*.json").sort
tabs.each do |path|
  file = File.read(path)
  tab_hash = JSON.parse(file)
  GenieacsGui::Application.config.menu.push(tab_hash)
end
