# Devices > show,
GenieacsGui::Application.config.device_mode = YAML.load_file('config/tplink/device_mode.yml')

# Devices > show without tab, background refresh nodes
GenieacsGui::Application.config.device_info_parameters = YAML.load_file('config/tplink/device_info_parameters.yml')

# Device > subpages required parameters
GenieacsGui::Application.config.subpage_parameters = YAML.load_file('config/tplink/device_subpage_parameters.yml')

# Devices > table and filters(shared)
GenieacsGui::Application.config.devices_index_parameters = YAML.load_file('config/tplink/devices_index_parameters.yml')

# Device > Info
GenieacsGui::Application.config.devices_summary_parameters = YAML.load_file('config/tplink/devices_summary_parameters.yml')
GenieacsGui::Application.config.devices98_summary_parameters = YAML.load_file('config/tplink/devices98_summary_parameters.yml')
GenieacsGui::Application.config.devices98_summary_parameters.each do |k, v|
  if not v.is_a?(Array)
    v = [v]
    GenieacsGui::Application.config.devices98_summary_parameters[k] = v
  end
end

GenieacsGui::Application.config.parameter_renderers = YAML.load_file('config/parameter_renderers.yml')

# devices > tr_tree
GenieacsGui::Application.config.parameters_edit = YAML.load_file('config/parameters_edit.yml')

# Devices related configuration
GenieacsGui::Application.config.device_config = YAML.load_file('config/tplink/device_config.yml')

module ParameterRenderers
  Dir['config/parameter_renderers/*.rb'].each { |file| load "./#{file}" }
end
