# we should combine this and wifi_scan_entry in the end
module DeviceShowWifiscan98
  def wifiscanbasic98(bandscan,dev_id,task_id,progress)
    http = create_api_conn()
    http.start()
    # wifi scan init ,default scan_count = 0
    if task_id == '' && progress == 'scan_start'
      @@scan_count = 0
      @@wifi_scan_task = { 'get_parametervalue': '', 'set_parametervalue': '', 'get_bssdescentry': '' }
    end
    if progress == 'scan_start' || progress == 'scan_result'
      @@scan_count += 1
    else
      @@scan_count += 5
    end
    # status : TimeOut
    if @@scan_count >= 60
      http.finish()
      agileACSLog(4, "[Device Detail][Wi-Fi Scan]#{dev_id}", 'Wi-Fi scan timeout.')
      destorywifiscan(dev_id, 'TimeOut","timeout')
      return
    end

    if task_id != '' # have task_id , query task is done?
      info = wifiscan_in_task_queue(http,task_id,dev_id)
      if info == task_id
        @@wifi_basic_scan[:status] = 'In Progress'
        @@wifi_basic_scan[:task_id] = task_id
        @@wifi_basic_scan[:total] = ''
        @@wifi_basic_scan[:progress] = progress
        @scan_wifi_result = ActiveSupport::JSON.decode(@@wifi_basic_scan.to_json)
        render json: @scan_wifi_result
        http.finish()
        return
      else
        @@wifi_scan_task.each { |k, v| @@wifi_scan_task[k] = '' if task_id == v }
        if progress == 'scan_start'
          progress = 'scan_refresh'
        elsif progress == 'scan_refresh'
          progress = 'scan_result'
        end
        task_id = ''
      end
    end

    if task_id == '' && progress == 'scan_start'
      # first click scan
      # ----------------------------------------------
      # refresh object X_TP_NeighbourScanEnabled
      # ----------------------------------------------
      refreshWlanScanParameter = { 'name': 'refreshObject', 'objectName': 'InternetGatewayDevice.LANDevice.1.WLANConfiguration.1.X_TP_NeighbourScanEnabled' }
      if bandscan == '2.4GH'
        refreshWlanScanParameter[:objectName] = 'InternetGatewayDevice.LANDevice.1.WLANConfiguration.1.X_TP_NeighbourScanEnabled'
      elsif bandscan == "5GHz"
        refreshWlanScanParameter[:objectName] = 'InternetGatewayDevice.LANDevice.1.WLANConfiguration.2.X_TP_NeighbourScanEnabled'
      end
      res_refresh = http.post("/devices/#{CGI.escape(dev_id)}/tasks?timeout=3000&connection_request", ActiveSupport::JSON.encode(refreshWlanScanParameter), 'Content-type' => 'application/json')
      res_refresh_task = JSON.parse(res_refresh.body)
      @@wifi_scan_task[:get_parametervalue] = res_refresh_task['_id']
      if res_refresh.code == '200' || res_refresh.code == '202' #keep 200 code , if else ...
        if res_refresh.message == 'Device is unreachable'
          flash[:warning] = res_refresh.message
          #status : <Empty> , progress : off-line
          http.finish()
          destorywifiscan(dev_id, '<Empty>', 'off-line')
          return
        end
      else
        flash[:error] = "Unexpected error (#{res_refresh.code}): #{res_refresh.body}"
        http.finish()
        destorywifiscan(dev_id, '<Empty>', 'off-line')
        return
      end
      # ----------------------------------------------
      # setParameterValues  X_TP_NeighbourScanEnabled = True ,start scan
      # ----------------------------------------------
      setWlanScanParameterEnable = { 'name': 'setParameterValues', 'parameterValues': '[[InternetGatewayDevice.LANDevice.1.WLANConfiguration.1.X_TP_NeighbourScanEnabled,true]]' }
      if res_refresh.code == '200' || res_refresh.code == '202' # 202 : off-line or queue ,this case is task in queue
        if bandscan == '2.4GHz'
          setWlanScanParameterEnable[:parameterValues] = ActiveSupport::JSON.decode('[[\"InternetGatewayDevice.LANDevice.1.WLANConfiguration.1.X_TP_NeighbourScanEnabled\",true]]')
        elsif bandscan == '5GHz'
          setWlanScanParameterEnable[:parameterValues] = ActiveSupport::JSON.decode('[[\"InternetGatewayDevice.LANDevice.1.WLANConfiguration.2.X_TP_NeighbourScanEnabled\",true]]')
        end
        res_scan = http.post("/devices/#{CGI.escape(dev_id)}/tasks?timeout=3000&connection_request", ActiveSupport::JSON.encode(setWlanScanParameterEnable), 'Content-type' => 'application/json')
        res_scan_task = JSON.parse(res_scan.body)
        @@wifi_scan_task[:set_parametervalue] = res_scan_task['_id']
        if res_scan.code == '200' || res_scan.code == '202'
          if res_scan.message == 'Device is unreachable'
            flash[:warning] = res_scan.message
            #status : <Empty> , progress : off-line
            http.finish()
            destorywifiscan(dev_id, '<Empty>', 'off-line')
            return
          end
          agileACSLog(6, "[Device Detail][Wi-Fi Scan]#{dev_id}", 'Start Wi-Fi scanning.')
        else
          flash[:error] = "Unexpected error (#{res_scan.code}): #{res_scan.body}"
          http.finish()
          destorywifiscan(dev_id, '<Empty>', 'off-line')
          return
        end
        @@wifi_basic_scan[:status] = 'In Progress'
        @@wifi_basic_scan[:task_id] = res_scan_task['_id']
        @@wifi_basic_scan[:total] = ''
        @@wifi_basic_scan[:progress] = 'scan_start'
        @@wifi_basic_scan[:rawdata] = nil
        @scan_wifi_result = ActiveSupport::JSON.decode(@@wifi_basic_scan.to_json)
        render json: @scan_wifi_result
      end
    elsif task_id == '' && progress == 'scan_refresh'
      info = wifiscanresult(bandscan,dev_id) # get db last update time
      @@last_scan_time = info['_timestamp']
      refreshWlanScanResult = {:name => "refreshObject", :objectName => "InternetGatewayDevice.LANDevice.1.WLANConfiguration.1.X_TP_BSSDescEntry" }
      if bandscan == "2.4GH"
        refreshWlanScanResult[:objectName] = "InternetGatewayDevice.LANDevice.1.WLANConfiguration.1.X_TP_BSSDescEntry"
      elsif bandscan == "5GHz"
        refreshWlanScanResult[:objectName] = "InternetGatewayDevice.LANDevice.1.WLANConfiguration.2.X_TP_BSSDescEntry"
      end
      res = http.post("/devices/#{CGI.escape(dev_id)}/tasks?timeout=3000&connection_request", ActiveSupport::JSON.encode(refreshWlanScanResult))
      res_task = JSON.parse(res.body)
      @@wifi_scan_task[:get_bssdescentry] = res_task['_id']
      if res.code == '200' || res.code == '202'
        if res.message == "Device is unreachable"
          flash[:warning] = res.message
          #status : <Empty> , progress : off-line
          http.finish()
          destorywifiscan(dev_id, "<Empty>", "off-line")
          return
        end
        agileACSLog(6, "[Device Detail][Wi-Fi Scan]#{dev_id}", "Get Wi-Fi scan results.")
      else
        flash[:error] = "Unexpected error (#{res.code}): #{res.body}"
        http.finish()
        destorywifiscan(dev_id, "<Empty>", "off-line")
        return
      end
      @@wifi_basic_scan[:status] = "In Progress"
      @@wifi_basic_scan[:task_id] = res_task['_id']
      @@wifi_basic_scan[:total] = ""
      @@wifi_basic_scan[:progress] = "scan_refresh"
      @@wifi_basic_scan[:rawdata] = nil
      @scan_wifi_result = ActiveSupport::JSON.decode(@@wifi_basic_scan.to_json)
      render json: @scan_wifi_result

    elsif task_id == "" && progress == "scan_result"
      # is DB redy and get result , if not send "scan_result"
      info = wifiscanresult(bandscan,dev_id)
      getlastscantime = info['_timestamp']
      if @@last_scan_time != getlastscantime && info['_scanresult'][0][:bssid] != ""
        @@wifi_basic_scan[:status] = "Completed Successfully"
        @@wifi_basic_scan[:task_id] = ""
        @@wifi_basic_scan[:total] = info['_wificount'].to_s
        @@wifi_basic_scan[:progress] = "scan_final"
        @@wifi_basic_scan[:rawdata] = info['_scanresult']

        if get_diagnostic_lock(dev_id)['result'] == "WifiScan"
          destory_diagnostic_lock(dev_id)
        end
        agileACSLog(6, "[Device Detail][Wi-Fi Scan]#{dev_id}", "Wi-Fi scan completed.")
        @scan_wifi_result = ActiveSupport::JSON.decode(@@wifi_basic_scan.to_json)
        render json: @scan_wifi_result
      else
        @@wifi_basic_scan[:status] = "In Progress"
        @@wifi_basic_scan[:task_id] = @@wifi_scan_task[:get_bssdescentry]
        @@wifi_basic_scan[:total] = ""
        @@wifi_basic_scan[:progress] = "scan_result"
        @scan_wifi_result = ActiveSupport::JSON.decode(@@wifi_basic_scan.to_json)
        render json: @scan_wifi_result
      end
    end
    http.finish()
  end

  def wifiscan_in_task_queue(http,task_id,dev_id)
    info = ''
    tasks = query_resource(http, 'tasks', { 'device' => dev_id }, nil, nil, nil, { 'timestamp' => 1 })[:result]
    info = task_id if tasks.to_s.include?(task_id)
    info
  end

  def wifiscanresult(band,dev_id)
    can?(:read, 'devices') do
      create_api_conn() do |http|
        res = query_resource(http, 'devices', { '_id' => dev_id })
        raise ActiveRecord::RecordNotFound if res[:result].size != 1
        scanentrycheck = res[:result][0]
        device_scan_params = flatten_params(scanentrycheck)
        includscanentry = '1.X_TP_BSSDescEntry'
        includscanentry = '2.X_TP_BSSDescEntry' if band == '5GHz'
        tmp = { '_timestamp' => '' }
        wificounts = 0
        scanresult_json = []
        wifi_entry = { 'id': '', 'ssid': '', 'bssid': '', 'rssi': '', 'channel': '', 'security': '', 'encryption': '' }
        for v in device_scan_params
          if v['_path'].include?(includscanentry)
            str_arr = v['_path'].split('.')
            if str_arr.last().gsub(/[^0-9]/, '') != '' && wificounts != 0
              wifi_entry[:id] = wificounts
              scanresult_json.push(wifi_entry)
              wifi_entry = { 'id': '', 'ssid': '', 'bssid': '', 'rssi': '', 'channel': '', 'security': '', 'encryption': '' }
            end
            case str_arr.last()
            when 'X_TP_BSSDescEntry'
              tmp['_timestamp'] = v['_timestamp']
            when 'SSID'
              wificounts += 1
              wifi_entry[:ssid] = v['_value'].to_s
            when 'BSSID'
              wifi_entry[:bssid] = v['_value'].to_s
            when 'RSSI'
              wifi_entry[:rssi] = v['_value'].to_s
            when 'Channel'
              wifi_entry[:channel] = v['_value'].to_s
            when 'AuthMode'
              wifi_entry[:security] = v['_value'].to_s
            when 'WepStatus'
              wifi_entry[:encryption] = v['_value'].to_s
            end
          end
        end
        tmp['_wificount'] = wificounts
        wifi_entry[:id] = wificounts
        scanresult_json.push(wifi_entry)
        tmp['_scanresult'] = scanresult_json
        return tmp
      end
    end
  end

  def destorywifiscan(dev_id, status,progress)
    http = create_api_conn()
    http.start()
    @@wifi_scan_task.each { |_, value| http.delete("/tasks/#{value}") if value != '' }
    destory_diagnostic_lock(dev_id) if get_diagnostic_lock(dev_id)['result'] == 'WifiScan'
    @@wifi_basic_scan[:status] = status
    @@wifi_basic_scan[:task_id] = ''
    @@wifi_basic_scan[:total] = ''
    @@wifi_basic_scan[:progress] = progress
    @@wifi_basic_scan[:rawdata] = nil
    http.finish()
    @@scan_count = 0
    @scan_wifi_result = ActiveSupport::JSON.decode(@@wifi_basic_scan.to_json)
    render json: @scan_wifi_result
  end

  def flatten_params(params, prefix = '')
    output = []
    params.each do |n, v|
      next if n.start_with?('_') || v.is_a?(String)

      v['_path'] = "#{prefix}#{n}"
      output << v

      unless v.include?('_value')
        output += flatten_params(v, prefix ? "#{prefix}#{n}." : "#{n}.")
      end
    end
    output
  end
end
