var padding, get_cmp_string, valcmp;
var APPENDIX;

APPENDIX = ["-FWSCHEDULE"];

remove_version_pro_channel_appendix = function(channel) {
    if (channel.includes(APPENDIX[0])) {
        channel = channel.replace(APPENDIX[0], "");
        }
  return channel;
}

padding = function (num,length){
    var len = (num + "").length;
    var diff = length - len;
    if (diff > 0){
      return Array(diff + 1).join("0") + num;
    }
    return num;
  }

get_cmp_string = function (diff, index) {
    var ret, ref1, ref2, ref3;
    
    try {
        if ((ref1 = diff[index])) {
            
            if ( (ref2 = ref1['object']) && ref2.length == 2 ) {
                ref3 = (ref3) ? ref3 + '#object.' + ref2[1] : 'object.'+ref2[1];
            }
            
            if ( (ref2 = ref1['writable']) && ref2.length == 2 ) {
                ref3 = (ref3) ? ref3 + '#writable.' + ref2[1] : 'writable.' + ref2[1];
            }
            
            if ( (ref2 = ref1['value']) && ref2.length == 2  ) {
                ref3 = (ref3) ? ref3 + '#value.' +  ref2[1].join("#") :  'value.' +ref2[1].join(".");
            }
            ret = ref3;
        }
    } catch (ex) {
        console.log(ex);
    }
    //console.log("get_cmp_string: " + diff[0].join(".") + ", diff["+index+"]: cmp_string="+ret);
    return ret;
};

// if diff[1] equals diff[2] (without timestamp), return false. otherwise, return true.
valcmp = function (diff) {
    // diff[0] = [ 'Device', 'ManagementServer', 'ConnectionRequestURL', alias: 0, wildcard: 0 ]
    // diff[1] = { value: [ 1573245340712, ['old_val', 'xsd:string'] ], writable: [ 1573239562663, 0 ], object: [ 1573245340712, 0 ] }
    //           or undefined
    // diff[2] = { value: [ 1573297812305, ['new_val', 'xsd:string'] ], writable: [ 1573239562663, 0 ], object: [ 1573297812305, 0 ] },

    var ref = diff[0].join('.');
    if (/Device\.WiFi\.MultiAP\.APDevice\.[0-9a-zA-Z-_]+\.(MACAddress|BackhaulLinkType|BackhaulMACAddress)/.test(ref)) {
        return true;
    }
    return ( get_cmp_string(diff, 1) == get_cmp_string(diff, 2) ) ? false : true;
};

exports.padding = padding;
exports.valcmp = valcmp;
exports.remove_version_pro_channel_appendix = remove_version_pro_channel_appendix;