let query = require('tplib/query');
let { agileConfig, stringTable, MongoClass } = require('tplib')
// let tpdb = new MongoClass(agileConfig.get(stringTable.url.dbTplink))
let tmpdb = new MongoClass(agileConfig.get(stringTable.url.dbTmp))
class AggregateQuery {
    expand(match_query) {
        var ret = match_query
        try {
            ret = query.expand(match_query)
        } catch (ex) {
            console.log(ex)
        }
        return ret
    }

    tmpDevice_aggregate_query(aggregate_pipeline) {
        return new Promise((resolve, reject) => {
            aggregate_pipeline.forEach((element) => {
                if (element['$match']) {
                    element['$match'] = this.expand(element['$match'])
                }
            })
            tmpdb.aggregate(stringTable.collection.tmpdevices, aggregate_pipeline, function (err, res) {
                if (err) {
                    reject(err)
                }
                resolve(res)
            })
        })
    }

    static destruct() {
        tmpdb.disconnectDb()
    }
}

module.exports = AggregateQuery