'use strict'

const koarouter = require('koa-router')
const { ProxyHandler } = require('tplib')

const subroute = new koarouter()
const subroutepath = __filename.split('/').pop().split('.')[0]
const proxyHandler = new ProxyHandler(null, 9)

subroute.use(require('koa-bodyparser')())

subroute.put(`/${subroutepath}/:id`, proxyHandler.handler)
subroute.delete(`/${subroutepath}/:id`, proxyHandler.handler)
subroute.all(`/${subroutepath}`, proxyHandler.handler)

subroute.destruct = () => {}

module.exports = subroute
