class DebugController < ApplicationController
    
    def index
        can?(:read, 'debug') do
        end
    end

    def new
        can?(:create, 'debug') do
            path = acsapps_debug
            unless path.blank?
                send_file path
            else
                redirect_to debug_path
            end    
        end
    end

    def acsapps_debug() 
        http = create_api_conn() 
        res = http.put("/acsapps/debug", nil) 
        if res.code == '200'
            res.body
        else 
            flash[:error] = "Unexpected error (#{res.code}): #{res.body}"
            nil
        end 
    end
end
