GenieacsGui::Application.routes.draw do
  get 'devices' => 'devices#index'
  post 'devices/select' => 'devices#destroy_select'
  post 'devices/:id/edit_info' => 'devices#edit_info'

  get 'devices_show/:id' => 'devices_show#show'
  get 'devices_show/:id/export' => 'devices_show#export_csv'
  get 'devices_show/:id/diaglock' => 'devices_show#diaglock'
  get 'devices_show/:id/tasks' => 'devices_show#get_tasks'
  get 'devices_show/:id/unlockDiag' => 'devices_show#unlockDiag'
  get 'devices_show/:id/diagresult' => 'devices_show#diagresult'
  post 'devices_show/:id/diag' => 'devices_show#update'
  post 'devices_show/:id' => 'devices_show#update'
  post 'devices_show/:id/retry_task' => 'devices_show#retry_task'
  delete 'devices_show/:id' => 'devices_show#destroy'
  delete 'devices_show/:id/task' => 'devices_show#remove_faulty_task'
  delete 'devices_show/:id/destroy_task' => 'devices_show#destroy_task'

  get 'ping/:id/:ip' => 'ping#index', :constraints => { ip: /[0-9\.]+|[0-9a-f:]+/ }
end
