GenieacsGui::Application.routes.draw do
  get 'system' => 'system#index'
  post 'system' => 'system#update'
  get 'system/time' => 'system#time'
  post 'system/cpesetting' => 'system#cpesetting'
  post 'system/upgrade' => 'system#upgrade'
  delete 'system/upgrade' => 'system#destroy'
  post 'system/reboot' => 'system#reboot'
  post 'system/poweroff' => 'system#poweroff'
  post 'system/cwmpsetting' => 'system#cwmpsetting'
  post 'system/cpemodels' => 'system#cpe_model_update'
  post 'system/ceipsetting' => 'system#set_ceip_setting'
  get 'system/ceiptest' => 'system#test_ceip'
end
