# Loggers Module
module Loggers
  include Util
  def agileACSLog(levelnum, object, content)
    file_path = '/var/log/genieacs/acs-operation.log'
    hostname = '127.0.0.1'
    level = ['[EMERGENCY]', '[ALERT]', '[CRITICAL]', '[ERROR]', '[WARN]', '[NOTICE]', '[INFO]', '[DEBUG]']

    content = content.gsub(': ', ':') while content.include? ': '

    File.open(file_path, 'a') do |f|
      f.puts Time.now.strftime('%Y-%m-%dT%H:%M:%S.%3NZ') + " #{level[levelnum]} #{levelnum} #{hostname} #{object}: #{content}"
      FileUtils.chown 'genieacs', 'genieacs', file_path.to_s
    end
  end
end
