# ---------------------------------------------------------------------------------------------------------
# module SystemModule
# History:
#     20200710 bill.chen  module extension functions, moved from SystemController or additional functions
# ---------------------------------------------------------------------------------------------------------
module SystemNbiUrl
  SYS_NBI_URL_STATUS = '/system/status'.freeze

  SYS_NBI_URL_ACSAPPS = '/system/acsapps'.freeze
  SYS_NBI_URL_CPE = '/system/cpe'.freeze

  SYS_NBI_URL_USAGE_CPU = '/system/usage/cpu'.freeze
  SYS_NBI_URL_USAGE_MEMORY = '/system/usage/memory'.freeze
  SYS_NBI_URL_USAGE_STORAGE = '/system/usage/storage'.freeze

  SYS_NBI_URL_MODELS_GET = '/system/models'.freeze
  SYS_NBI_URL_CEIP = '/system/ceip'.freeze
  SYS_NBI_URL_SYSSETTING = '/system/syssetting'.freeze


  SYS_NBI_URL_XMPP = '/system/xmpp'.freeze

  # -----------------------------------------------------------------------
  #   SYS_NBI_URL_STATUS = '/system/status'.freeze

  #   SYS_NBI_URL_ACSAPPS_SYSTEM = '/acsapps/system'.freeze
  #   SYS_NBI_URL_ACSAPPS_CWMP = '/acsapps/system'.freeze
  #   SYS_NBI_URL_ACSAPPS_UPGRADE = '/acsapps/upgrade'.freeze
  #   SYS_NBI_URL_ACSAPPS_RESTART = '/acsapps/restart'.freeze
  #   SYS_NBI_URL_ACSAPPS_SHUTDOWN = '/acsapps/shutdown'.freeze

  #   SYS_NBI_URL_CPE_SET = '/cpesetting/update'.freeze
  #   SYS_NBI_URL_CPE_GET = 'cpesetting'.freeze

  #   SYS_NBI_URL_USAGE_CPU = '/cpu/usage'.freeze
  #   SYS_NBI_URL_USAGE_MEMORY = '/memory/usage'.freeze
  #   SYS_NBI_URL_USAGE_STORAGE = '/storage/usage'.freeze

  #   SYS_NBI_URL_MODELS_GET = 'model'.freeze
  #   SYS_NBI_URL_MODELS_CFG = '/acsapps/config'.freeze

  #   SYS_NBI_URL_CEIP_SET = '/activateReport/save_info'.freeze
  #   SYS_NBI_URL_CEIP_GET = 'activateReport'.freeze
  # -----------------------------------------------------------------------
end
