'use strict'

const koarouter = require('koa-router')

const subroute = new koarouter()
const subroutepath = __filename.split('/').pop().split('.')[0]
let ProfileProgress = require('./class/profile_progress')

let getAllProfileProgress = async (progress_querys) => {
  let profileprogress = new ProfileProgress()
  return profileprogress.get_profileprogress_all(progress_querys)
    .then((results) => {
      return results
    })
    .catch((err) => {
      return err
    })
}

subroute.post(`/${subroutepath}`, async (ctx) => {
  let body = ctx.request.body
  if (!ctx.request.length) {
    ctx.throw(400)
  }
  try {
    let res = await getAllProfileProgress(body)
    ctx.set('total', res.length)
    ctx.body = res
  } catch (e) {
    ctx.throw(400, e.name, { message: e.message })
  }
})

subroute.destruct = () => {}

module.exports = subroute
