'use strict'

const koarouter = require('koa-router')
const { ProxyHandler } = require('tplib')

const subroute = new koarouter()
const subroutepath = __filename.split('/').pop().split('.')[0]
const proxyHandler = new ProxyHandler(null, 9)

// proxy needs to leave body un-parsed
subroute.use(proxyHandler.streamBodyParser)

subroute.get(`/${subroutepath}`, proxyHandler.handler)

subroute.destruct = () => {}

module.exports = subroute
